<h1 id="toast">Toast</h1>
<p>A Toast is a component that is used to convey an important message to the user for a short period of time. Toasts do not require user input and disappear after a set period of time. For messages that require user input use the ACE <a href="/modal">Modal component</a> instead.</p>
<p>Note that when using multiple Toasts they occupy the same fixed position at the bottom of the viewport window. Developers should therefore add a way of dealing with multiple Toasts appearing at the same time if this is a possibility. An example of how this can be achieved using JavaScript is shown in the examples section below.</p>
<p>Toast conforms to the <a href="http://w3.org/WAI/WCAG21/Techniques/aria/ARIA22.html">W3C WAI-ARIA authoring practices</a>.</p>
<h2 id="setup">Setup</h2>
<p>First import the styles into your main SASS file, replacing <code>&lt;path-to-node_modules&gt;</code> with the path to the <em>node_modules</em> directory relative to the file:</p>
<pre><code class="language-scss">@import '&lt;path-to-node_modules&gt;/@potato/ace/components/toast/toast';
</code></pre>
<p>Alternatively <em>ace.scss</em> includes all ACE component SASS files, so if using multiple ACE components it can be imported instead:</p>
<pre><code class="language-scss">@import '&lt;path-to-node_modules&gt;/@potato/ace/ace';
</code></pre>
<p>A CSS file is also provided for convenience and is located at <code>&lt;path-to-node_modules&gt;/@potato/ace/components/toast/ace-toast.css</code>.</p>
<p>Then import the class into your JavaScript entry point:</p>
<pre><code class="language-js">import '&lt;path-to-node_modules&gt;/@potato/ace/components/toast/toast';
</code></pre>
<p>For convenience the ES6 class is exported as <code>Toast</code> and the attribute names used by the class are exported as properties of <code>ATTRS</code>.</p>
<p>After the event <code>DOMContentLoaded</code> is fired on <code>document</code> an instance of Toast is instantiated within each <code>&lt;ace-toast&gt;</code> element and an ID <code>ace-toast-&lt;n&gt;</code> is added for any instance without one, where <code>&lt;n&gt;</code> is a unique integer. If the instance of Toast doesn't have a child with attribute <code>ace-toast-inner</code>, a child <code>div</code> is created, given this attribute and all other children of the Toast instance are moved into it. Once instantiation is complete a custom event <code>ace-toast-ready</code> is dispatched to <code>window</code>. See the <strong>Custom events</strong> section below for more details.</p>
<h2 id="usage">Usage</h2>
<p>Toasts have an attribute <code>ace-toast-visible</code> which is initially set to <code>false</code>. This is an observed attribute and therefore dynamically be set to <code>true</code> which will cause the Toast to appear for a default time of 4 seconds before disappearing. Developers can specify a custom show-time by setting attribute <code>ace-toast-show-time</code> to the value of the show-time in milliseconds as demonstrated in the example below.</p>
<h2 id="styles">Styles</h2>
<p>The following SASS is applied to Toast. The SASS variables use <code>!default</code> so can also be easily overridden by developers. SASS variables used that are not defined here are defined in <em>&lt;path-to-node_modules&gt;/@potato/ace/common/constants.scss</em>.</p>
<pre><code class="language-scss">@import '../../common/constants';


// VARIABLES
$ace-toast-bg-color: #000 !default;
$ace-toast-border-radius: 8px !default;
$ace-toast-breakpoint: 600px !default;
$ace-toast-distance-from-bottom: 32px !default;
$ace-toast-font-size: 16px !default;
$ace-toast-max-width: 500px !default;
$ace-toast-mobile-max-width: 300px !default;
$ace-toast-padding: 16px !default;
$ace-toast-text-color: #fff !default;


// STYLES
ace-toast {
	background: $ace-toast-bg-color;
	border-radius: $ace-toast-border-radius;
	bottom: $ace-toast-distance-from-bottom;
	color: $ace-toast-text-color;
	font-size: $ace-toast-font-size;
	left: 50%;
	max-width: $ace-toast-mobile-max-width;
	padding: $ace-toast-padding;
	position: fixed;
	transform: translateX(-50%);
	z-index: $ace-toast-z-index;

	&amp;:not([ace-toast-visible]) {
		display: none;
	}

	@media (min-width: $ace-toast-breakpoint) {
		max-width: $ace-toast-max-width;
	}
}
</code></pre>
<h2 id="custom-events">Custom events</h2>
<p>Toast uses the following custom events, the names of which are available in its exported <code>EVENTS</code> object, similar to <code>ATTRS</code>, so they may be imported into other modules.</p>
<h3 id="dispatched-events">Dispatched events</h3>
<p>The following events are dispatched to <code>window</code> by Toast.</p>
<h4 id="ready">Ready</h4>
<p><code>ace-toast-ready</code></p>
<p>This event is dispatched when Toast finishes initialising. The event name is available as <code>EVENTS.OUT.READY</code> and its <code>detail</code> property is composed as follows:</p>
<pre><code class="language-js">'detail': {
	'id': // ID of Toast [string]
}
</code></pre>
<h4 id="changed">Changed</h4>
<p><code>ace-toast-visibility-changed</code></p>
<p>This event is dispatched when Toast visibility changes. The event name is available as <code>EVENTS.OUT.VISIBILITY_CHANGED</code> and its <code>detail</code> property is composed as follows:</p>
<pre><code class="language-js">'detail': {
	'id': // ID of Toast [string]
	'visible': // Whether Toast is visible or not [boolean]
}
</code></pre>
<h2 id="examples">Examples</h2>
<p>Each example contains a live demo and the HTML code that produced it. The code shown may differ slightly to that rendered for the demo as some components may alter their HTML when they initialise.</p>
<h3 id="simple-toast-and-short-show-time-toast">Simple Toast and short show-time Toast</h3>
<p>A Toast with a default 4 second show-time and one with a custom 2 second show-time. The JavaScript used by this example is shown below.</p>
<div class="example-block"><button id="simple-toast-btn">Show Toast</button>
<button id="short-show-time-toast-btn">Show Toast with 2 second show-time</button>
<ace-toast>
	Toast with standard 4 second show-time
</ace-toast>
<ace-toast ace-toast-show-time="2000">
	Toast with developer-defined 2 second show-time
</ace-toast>
</div>
<pre><code class="language-html">&lt;button id=&quot;simple-toast-btn&quot;&gt;Show Toast&lt;/button&gt;
&lt;button id=&quot;short-show-time-toast-btn&quot;&gt;Show Toast with 2 second show-time&lt;/button&gt;

&lt;ace-toast&gt;
	Toast with standard 4 second show-time
&lt;/ace-toast&gt;

&lt;ace-toast ace-toast-show-time=&quot;2000&quot;&gt;
	Toast with developer-defined 2 second show-time
&lt;/ace-toast&gt;
</code></pre>
<pre><code class="language-js">import { ATTRS } from '/ace/components/toast/toast.js';

document.addEventListener('DOMContentLoaded', () =&gt; {
	const toastEl = document.getElementById('ace-toast-1');
	const secondToastEl = document.getElementById('ace-toast-2');
	const showToastBtn = document.getElementById('simple-toast-btn');
	const showSecondToastBtn = document.getElementById('short-show-time-toast-btn');

	showToastBtn.addEventListener('click', () =&gt; toastEl.setAttribute(ATTRS.VISIBLE, ''));
	showSecondToastBtn.addEventListener('click', () =&gt; secondToastEl.setAttribute(ATTRS.VISIBLE, ''));
});
</code></pre>
<h3 id="multiple-toasts">Multiple Toasts</h3>
<p>This example demonstrates how JavaScript can be used to deal with multiple toasts appearing at the same time.</p>
<div class="example-block"><button id="show-1st-toast-btn">Show first Toast</button>
<button id="show-2nd-toast-btn">Show second Toast</button>
<button id="show-3rd-toast-btn">Show third Toast</button>
<ace-toast>
	First Toast
</ace-toast>
<ace-toast>
	Second Toast
</ace-toast>
<ace-toast>
	Third Toast
</ace-toast>
</div>
<pre><code class="language-html">&lt;button id=&quot;show-1st-toast-btn&quot;&gt;Show first Toast&lt;/button&gt;
&lt;button id=&quot;show-2nd-toast-btn&quot;&gt;Show second Toast&lt;/button&gt;
&lt;button id=&quot;show-3rd-toast-btn&quot;&gt;Show third Toast&lt;/button&gt;
&lt;ace-toast&gt;
	First Toast
&lt;/ace-toast&gt;
&lt;ace-toast&gt;
	Second Toast
&lt;/ace-toast&gt;
&lt;ace-toast&gt;
	Third Toast
&lt;/ace-toast&gt;
</code></pre>
<pre><code class="language-js">import { ATTRS } from '/ace/components/toast/toast.js';

document.addEventListener('DOMContentLoaded', () =&gt; {
	const firstToastId = 'ace-toast-3';
	const secondToastId = 'ace-toast-4';
	const thirdToastId = 'ace-toast-5';
	const firstToastEl = document.getElementById(firstToastId);
	const secondToastEl = document.getElementById(secondToastId);
	const thirdToastEl = document.getElementById(thirdToastId);

	const positionToast = (toastEl) =&gt; {
		const TOAST_GAP = 10;
		let offsetTopOfHighestToast;
		const visibleToasts = document.querySelectorAll(`[${ATTRS.VISIBLE}]`);

		visibleToasts.forEach((visibleToast, index) =&gt; {
			const visibleToastOffsetTop = visibleToast.offsetTop;

			if (index === 0) {
				offsetTopOfHighestToast = visibleToastOffsetTop;
				return;
			}

			if (visibleToastOffsetTop &lt; offsetTopOfHighestToast) {
				offsetTopOfHighestToast = visibleToastOffsetTop;
			}
		});
		toastEl.style.bottom = visibleToasts.length ? `${window.innerHeight - offsetTopOfHighestToast + TOAST_GAP}px` : '';
	};

	window.addEventListener('click', (e) =&gt; {
		const targetId = e.target.id;
		let toastEl;
		toastEl = targetId === 'show-1st-toast-btn' ? firstToastEl : toastEl;
		toastEl = targetId === 'show-2nd-toast-btn' ? secondToastEl : toastEl;
		toastEl = targetId === 'show-3rd-toast-btn' ? thirdToastEl : toastEl;

		if (!toastEl) {
			return;
		}

		positionToast(toastEl);
		toastEl.setAttribute(ATTRS.VISIBLE, '');
	});
});
</code></pre>
